import os, os.path, fnmatch, sys, string

from config import do_debug, do_log

if do_debug:
    def debug(text):
        print text
else:
    def debug(text):
        pass


if do_log:
    class Log:
        def __init__(self, logfile=None):
            if not logfile:
                if sys.platform[:3] == 'win':
                    logfile = "c:/napyrc.log"
                else:
                    logfile = "/tmp/napyrc.log"
            self.f = open(logfile, "a")
        def log(self, text):
            self.f.write(text+"\n")
            self.f.flush()
        def __del__(self):
            self.f.close()
else:
    class Log:
        def __init__(self, logfile=None):
            pass
        def log(self, text):
            pass

