#!/usr/bin/python
# maybe you need to change the above line

import sys, socket, string, os, time, fnmatch, types
from stat import *
import select, random
import SocketServer
import ntpath, fileinput
import mp3infor
from utils import *

from logging import *
from config import *

    
def isshared(file):
    return 1

uploads = {}

class UploadingSession:

    def __init__(self, connection, client_address):
        self.ip = client_address[0]
        self.exit_immediately = 0
        self.limit_upload_speed = upload_speed
        self.connection = connection
        self.uploaded_size = 0

    def go(self):
        debug("begin upload")
        try:
            self.connection.send("1")
            s = self.connection.recv(3)
            debug("should be GET:%s" %s)
            s = self.connection.recv(500) 
            debug("download req.:%s" % s)
            self.downloader, self.file, resume = nsplit(s)
            #session.irc_notice("%s downloads %s" % (self.downloader,  self.file))
            self.file = v2fs(self.file)
            if not isshared(self.file):
                self.connection.send("FILE NOT SHARED")
                self.connection.close()
                session.irc_notice("FILE NOT SHARED: %s %s" % (self.downloader,  self.file))
                return
            resume = int(resume)
            try:
                size = os.stat(self.file)[ST_SIZE]
                f = open(self.file, "rb")
                f.seek(resume)
            except (IOError, OSError):
                self.connection.send("INVALID REQUEST")
                self.connection.close()
                session.irc_notice("INVALID REQUEST: %s %s" % (self.downloader,  self.file))
                return
            self.size = size
            self.connection.send(str(size))
            session.nap_sock.send(220)
            r = "Uploading completed"
            while 1:
                s = f.read(sbufsize)
                if not s:
                    break
                if self.limit_upload_speed:
                    timer = time.time()
                    self.connection.send(s)
                    dur = time.time()-timer
                    #speed = len(s)/dur
                    #if speed>self.limit_retr_speed:
                    if dur*self.limit_upload_speed<len(s): # to avoid division
                        time.sleep(len(s)/self.limit_upload_speed-dur)
                else:
                    self.connection.send(s)
                self.uploaded_size = self.uploaded_size+len(s)
        except socket.error, why:
            r = "Uploading broken %s" % `why`
        f.close()
        try:
            self.connection.close()
        except socket.error:
            pass
        session.nap_sock.send(221)
        session.irc_notice("%s: %s %s" % (r, self.downloader,  self.file))
        
        
# the main fun is here
class Session:

    def __init__(self, rfile, wfile, client_address):
    
        self.nick = self.user = ""
        self.passwd = ""
        self.ip = client_address[0]
        self.group = ""
        self.exit_immediately = 0
        self.pendingconn = 0 # if there is an open data connection - for ABOR
        self.irc_rfile = rfile
        self.irc_wfile = wfile
        
        ns = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.nap_sock = NapSock(ns)

        self.cache = []


        self.irc_cmddict = {
            "QUIT": self.irc_cmd_QUIT,
            "NICK": self.irc_cmd_NICK,
            "JOIN": self.irc_cmd_JOIN,
            "PART": self.irc_cmd_PART,
            "LIST": self.irc_cmd_LIST,
            "MODE": self.irc_cmd_dummy,
            "WHOIS": self.irc_cmd_WHOIS,
            "WHOWAS": self.irc_cmd_WHOWAS,
            "PRIVMSG": self.irc_cmd_PRIVMSG,
            "NOTICE": self.irc_cmd_PRIVMSG,
            "USER": self.irc_cmd_USER
            }

        self.nap_cmddict = {
            3: self.nap_cmd_LOGIN_ACK,
            201: self.nap_cmd_SEARCH_RESPONSE,
            202: self.nap_cmd_SEARCH_RESPONSE_END,
            204: self.nap_cmd_DOWNLOAD_ACK,
            205: self.nap_cmd_MSG,
            206: self.nap_cmd_GET_ERROR,
            210: self.nap_cmd_USER_SIGNOFF,
            212: self.nap_cmd_BROWSE_RESPONSE,
            213: self.nap_cmd_BROWSE_RESPONSE_END,
            214: self.nap_cmd_STATS,
            401: self.nap_cmd_PART,
            403: self.nap_cmd_PUB_MSG,
            404: self.nap_cmd_ERROR,
            405: self.nap_cmd_JOIN_ACK,
            406: self.nap_cmd_JOIN_MESSAGE,
            406: self.nap_cmd_PART_MESSAGE,
            408: self.nap_cmd_CHANNEL_ENTRY,
            409: self.nap_cmd_CHANNEL_DONE,
            410: self.nap_cmd_CHANNEL_TOPIC,
            604: self.nap_cmd_WHOIS_RESPONSE,
            605: self.nap_cmd_WHOWAS_RESPONSE,
            607: self.nap_cmd_UPLOAD_REQUEST,
            609: self.nap_cmd_GET_ERROR,
            617: self.nap_cmd_LIST_CHANNEL,
            618: self.nap_cmd_LIST_ENTRY,
            620: self.nap_cmd_QUEUE_LIMIT,
            621: self.nap_cmd_MOTD,
            626: self.nap_cmd_DATA_PORT_ERROR,
            748: self.nap_cmd_LOGIN_ATTEMPT
            }

    def download(self, ip, port, filename):
        fname = string.split(ntpath.normpath(filename), "\\")[-1]
        offset = 0
        sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        os.chdir(download_dir)
        try:
            sock.connect((ip, port))
            a = sock.recv(1)
        except socket.error, why:
            self.irc_notice("Error downloading %s: %s" % (fname, str(why)))
            return
        debug("should be 1: %s" % a)
        sock.send("GET")
        sock.send('%s "%s" %i' % (mynick, filename, offset))
        l=''
        while 1:
            s = sock.recv(1)
            if not s in string.digits:
                break
            l = l+s
        if not l:
            s = s+sock.recv(30)
            self.irc_notice("Error downloading %s: %s" % (fname, s))
            return
        debug("expected length: %s" % l)
        self.nap_sock.send(218)
        f = open(fname, "wb")
        f.write(s)
        while 1:
            s = sock.recv(rbufsize)
            if len(s) == 0:
                break
            f.write(s)
        f.close()
        sock.close()
        self.irc_notice("Download completed: %s" % fname)
        self.nap_sock.send(219)

    if use_shared_file:
        def send_list(self):
            self.irc_notice("Sending file list")
            try:
                for i in fileinput.input("shared"):
                    t, file, md5hash, size, bitrate, frequency, length = \
                        nsplit(i)
                    self.nap_sock.send(100, '"%s" %s %s %s %s %s' % (file, md5hash, size, bitrate, frequency, length))
            finally:
                fileinput.close()
            self.irc_notice("Sending file list completed.")
    else:
        def send_one_item(self, arg, dirname, names):
            for i in names:
                if filter(lambda x, y=i, fn=fnmatch.fnmatch: fn(y, x), shared_patterns) <> []:
                    fname = os.path.join(dirname, i)
                    if os.path.isfile(fname):
                        md5hash, size, bitrate, frequency, length = mp3info(fname)
                        if size<>0:
                            self.nap_sock.send(100, '"%s" %s %i %i %i %i' % (fs2v(fname), md5hash, size, bitrate, frequency, length))
                            #print '"%s" %s %i %i %i %i' % (fs2v(fname), md5hash, size, bitrate, frequency, length)
            
        def send_list(self):
            self.irc_notice("Sending file list")
            walk(shared_dir, self.send_one_item, None)
            self.irc_notice("Sending file list completed.")
    
    def irc_reply(self, n, x):
        self.irc_wfile.write(":localhost.localdomain %03i %s %s\r\n" % (n, self.nick, x))
        #self.irc_wfile.write("%i %s %s\r\n" % (n, self.nick, x))
        #debug("R:"+repr(x))

    def irc_notice(self, x, frm=None):
        if not frm:
            frm = "napyrc"
        debug(":%s NOTICE %s :%s" % (frm, self.nick, x))
        self.irc_raw(":%s NOTICE %s :%s" % (frm, self.nick, x))

    def irc_console(self, x, frm=None):
        if not frm:
            frm = "napyrc@napster.com"
        frm = "napyrc%02i!%s" % (random.randint(0, 99), frm)
        self.irc_raw(":%s PRIVMSG &console :%s" % (frm, x))
    

    def irc_raw(self,  x):
        self.irc_wfile.write(x+"\r\n")
        #debug("R:"+repr(x))

    def irc_cmd_dummy(self, *args):
        return
            
    def irc_cmd_QUIT(self, message=""):
        raise "session_exit"

    def irc_cmd_NICK(self, nickname, hopcount=0):
        global mynick
        self.nick = nickname
        mynick = nickname
        self.passwd = napster_password
        self.irc_checklogin()

    def irc_cmd_JOIN(self, channel, key=""):
        if channel[0] == "#":
            napch = channel[1:]
            self.nap_sock.send(400, napch)
        elif channel[0] == "&":
            self.irc_raw(":%s!heh@napster.com JOIN :%s" % (self.nick, channel))

    def irc_cmd_PART(self, channel):
        if channel[0] == "#":
            napch = channel[1:]
            self.nap_sock.send(401, napch)
        elif channel[0] == "&":
            self.irc_raw(":%s!heh@napster.com PART :%s" % (self.nick, channel))

    def irc_cmd_USER(self, username, hostname, servername, realname):
        self.user = username
        self.irc_checklogin()

    def irc_cmd_WHOIS(self, sorn, nick=None):
        if not nick:
            nick = sorn
        self.nap_sock.send(603, nick)

    def irc_cmd_WHOWAS(self, nick, c=0, server=""):
        self.nap_sock.send(603, u)

    def irc_checklogin(self):
        if self.nick and self.user:
            if napster_use_meta:
                sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                sock.connect((napster_metaserver, napster_meta_port))
                r = sock.recv(80)
                sock.close()
                r = string.split(r, '\012', 1)[0]
                host, port = string.split(r,":")
                port = int(port)
            else:
                host, port = napster_server, napster_port
            debug("Connecting to %s:%s" % (host, port))

            self.nap_sock.connect((host, port))
            self.nap_sock.send(2, '%s %s %i "napyrc" 0' % (self.nick, self.passwd, client_port))
            self.irc_reply(001, ":Hello1")
            self.irc_reply(002, ":Hello2")
            self.irc_reply(003, ":Hello3")
            self.irc_reply(004, "localhost.localdomain 0.0 aoOirw abeiIklmnoOpqrstv")

    def irc_cmd_LIST(self, channel="", server=""):
        self.nap_sock.send(617)
        
    def irc_cmd_PRIVMSG(self, reciever, text):
        u = reciever
        m = text
        if u[0] == "#": #channel
            self.nap_sock.send(402, "%s %s" %(u[1:], m))
        elif u[0] == "&": #command channel
            if u == "&console":
                list = string.split(m, " ", 1)
                command = list[0]
                if len(list) == 2:
                    arg = list[1]
                else:
                    arg = ''
                command = string.lower(command)
                if command in ("search", "find"):
                    self.nap_sock.send(200, 'FILENAME CONTAINS "%s" MAX_RESULTS 20' % arg)
                elif command in ("get", "download"):
                    if string.count(arg, " ") == 0: # cache number
                        i = int(arg)
                        nick, file = self.cache[i]
                    else:
                        nick, file = string.split(arg, " ", 1)
                    self.nap_sock.send(203, '%s "%s"' % (nick, file))
                elif command in ("browse", "dir", "ls"):
                    self.nap_sock.send(211, arg)
                elif command in ("ps", "who"):
                    for i in uploads.keys():
                        try:
                            u = uploads[i]
                            percentage = 100*u.uploaded_size/(u.size+1)
                            self.irc_console('%4i %s "%s" %i%%' % (i, u.downloader, u.file, percentage))
                        except KeyError:
                            pass
                elif command == "exec":
                    exec(arg)
        else:
            self.nap_sock.send(205, "%s %s" % (u, m))

    def nap_cmd_STATS(self, m):
        m = nsplit(m)
        users = int(m[0])
        files = size = 0
        if len(m) > 1:
            files = int(m[1])
        if len(m) > 2:
            size = int(m[2])
        r = ":There are %i users sharing %i files (%i GB)." % (users, files, size)
        self.irc_reply(251, r)
        self.irc_reply(255, r+" Whoa.")


    def nap_cmd_DOWNLOAD_ACK(self, arg):
        nick, ip, port, filename, md5hash, linespeed = nsplit(arg)
        ip = makeip(ip)
        port = int(port)
        thread.start_new_thread(self.download, (ip, port, filename))
        

    def nap_cmd_SEARCH_RESPONSE(self, m):
        m = nsplit(m)
        filename, md5hash, size, bitrate, frequency, length, nick, ip, link_type = m[:9]
        #self.irc_console(
        #        "%s %s %s %s %s %s %s %s %s %s" % 
        #            (filename, md5hash, size, bitrate, frequency, length, nick, ip, link_type, c),
        #        "search")
        size = format_size(int(size))
        frequency = int(frequency)/1000
        length = format_length(int(length))
        ip = makeip(ip)
        i = len(self.cache)
        self.cache.append( (nick, filename) )
        self.irc_console('%4i "%s" %s %skb/s %ikHz %s %s %s' % (i, filename, size, bitrate, frequency, length, nick, ip), "search@napster.com")


    def nap_cmd_SEARCH_RESPONSE_END(self,_):
        self.irc_console("Search done.", "search")

    def nap_cmd_BROWSE_RESPONSE(self, m):
        nick, filename, md5hash, size, bitrate, frequency, length = \
            nsplit(m)
        #self.irc_console(
        #        "%s %s %s %s %s %s %s %s %s %s" % 
        #            (filename, md5hash, size, bitrate, frequency, length, nick, ip, link_type, c),
        #        "search")
        size = format_size(int(size))
        frequency = int(frequency)/1000
        length = format_length(int(length))
        i = len(self.cache)
        self.cache.append( (nick, filename) )
        self.irc_console('%4i %s "%s" %s %skb/s %ikHz %s' % (i, nick, filename, size, bitrate, frequency, length), "browse@napster.com")

    def nap_cmd_BROWSE_RESPONSE_END(self,_):
        self.irc_console("Browse done.", "browse")

    def nap_cmd_MSG(self, m):
        nick, message = nsplit(m, 1)
        self.irc_raw(":%s!heh@napster.com PRIVMSG %s :%s" % (nick, self.nick, message))

    def nap_cmd_PUB_MSG(self, m):
        channel, nick, message = nsplit(m, 2)
        self.irc_raw(":%s!heh@napster.com PRIVMSG %s :%s" % (nick, "#"+channel, message))

    def nap_cmd_PART(self, m):
        m = "#"+m
        self.irc_raw(":%s!heh@napster.com PART :%s" % (self.nick, m))

    def nap_cmd_JOIN_ACK(self, m):
        m = "#"+m
        self.irc_raw(":%s!heh@napster.com JOIN :%s" % (self.nick, m))

    def nap_cmd_JOIN_MESSAGE(self, m):
        channel, user, sharing, link_type = nsplit(m)
        self.irc_raw(":%s!heh@napster.com JOIN :%s" % (user, "#"+channel))

    def nap_cmd_CHANNEL_ENTRY(self, m):
        channel, user, sharing, link_type = nsplit(m)
        self.irc_raw(":%s!heh@napster.com JOIN :%s" % (user, "#"+channel))

    def nap_cmd_PART_MESSAGE(self, m):
        channel, user, sharing, link_type = nsplit(m)
        self.irc_raw(":%s!heh@napster.com PART :%s" % (user, "#"+channel))

    #def nap_cmd_CHANNEL_ENTRY(self, m):
    #    channel, user, sharing, link_type = nsplit(m)
    #    self.irc_reply(353, "= %s :%s" % ("#"+channel, user))

    def nap_cmd_CHANNEL_DONE(self, m):
        channel = m
        self.irc_reply(366, "%s :%s" % (channel, "The end"))

    def nap_cmd_CHANNEL_TOPIC(self, m):
        channel, topic = nsplit(m, 1)
        self.irc_reply(332, "%s :%s" % (channel, topic))

    def nap_cmd_ERROR(self, m):
        self.irc_notice(m)

    def nap_cmd_USER_SIGNOFF(self, m):
        self.irc_notice('%s logged off' % m)

    def nap_cmd_UPLOAD_REQUEST(self, m):
        nick, filename = nsplit(m)[:2]
        c = 0 # count how many times given nick already downloads
        u = uploads
        for i in uploads.keys():
            if uploads[i].downloader == nick:
                c = c+1
        if len(uploads) >= upload_limit or c >= per_user_upload_limit:
            self.irc_notice('%s wants but won\'t get "%s"'% (nick, filename))
            self.nap_sock.send(619, '%s "%s" %i' % (nick, filename, upload_limit))
        else:
            self.irc_notice('%s wants "%s"' % (nick, filename))
            self.nap_sock.send(608, '%s "%s"' % (nick, filename))

    def nap_cmd_GET_ERROR(self, m):
        nick, filename = nsplit(m)
        self.irc_notice("Error getting %s" % filename)

    def nap_cmd_WHOIS_RESPONSE(self, arg):
        arg = nsplit(arg)
        user, user_level, t, channels, status, shared, \
        downloads, uploads, link_type, client_info = arg[:10]
        total_downloads = total_uploads = ip = port = dataport = email = ""
        if len(arg) == 16:
            total_downloads, total_uploads, ip, port, dataport, email = arg[10:]
        #user, level, last_seen = string.split(arg, 2)
        #self.irc_reply(314, "%s %s napster.com * :%s" % (user, level, user)) 
        self.irc_reply(311, "%s napster.com * :%s" % (user, ip))
        self.irc_reply(312, "%s napster.com :%s" % (user, ip))
        self.irc_reply(319, "%s napster.com :%s" % (user, channels))
        self.irc_reply(318, "%s :The End" % (user))
        self.irc_notice("%s: level %s, connected %ss, status %s" % (user, user_level, t, status))
        self.irc_notice("%s: shared %s, downloads %s, uploads %s" % (user, shared, downloads, uploads))
        self.irc_notice("%s: link %s, client %s" % (user, link_type, client_info))
        if total_downloads:
            self.irc_notice("%s: total downloads %s" % (user, total_downloads))
        if total_uploads:
            self.irc_notice("%s: total uploads %s" % (user, total_uploads))
        if ip or port:
            self.irc_notice("%s: IP %s:%s" % (user, ip, port))
        if email:
            self.irc_notice("%s: E-Mail %s" % (user, email))


    def nap_cmd_WHOWAS_RESPONSE(self, arg):
        user, level, last_seen = nsplit(arg)
        last_seen = long(last_seen)
        self.irc_reply(314, "%s %s napster.com * :%s" % (user, level, time.ctime(last_seen))) 
        self.irc_reply(312, "%s napster.com * :%s" % (user, time.ctime(last_seen)))
        self.irc_reply(369, "%s :The End" % (user))

    def nap_cmd_MOTD(self, m):
        self.irc_reply(375, ":"+m)
        list = [self.nap_sock.sock]
        while 1:
            lnap = ""
            r,w,e = select.select(list, [], [], 10)
            if not r:
                self.irc_reply(376, ":End of napster MOTD. Ugh.")
                break
            else:
                lnap = self.nap_sock.receive()
                if not lnap: # connection broken
                    self.irc_notice("Napster server kicked you out")
                    raise "session_exit"
                if lnap[0] == 621: # motd still going on
                    self.irc_reply(372, ":"+lnap[1])
                else:
                    self.irc_reply(376, ":End of napster MOTD. Ugh.")
                    self.donap(lnap)
                    break

    def nap_cmd_LIST_ENTRY(self, m):
        channel, users, topic = string.split(m, " ", 2)
        self.irc_reply(322, "%s %s :%s" % (channel, users, topic))

    def nap_cmd_LIST_CHANNEL(self, m):
        self.irc_reply(323, m)

    def nap_cmd_LOGIN_ACK(self, m):
        #self.irc_reply(002, ":Login successful %s" % m)
        self.irc_notice("Login successful %s" % m)
        thread.start_new_thread(self.send_list, ())

    def nap_cmd_QUEUE_LIMIT(self, m):
        nick, filename, filesize, digit = nsplit(m)
        #self.irc_reply(002, ":Login successful %s" % m)
        self.irc_notice("%s has a limit for %s connections" % (nick, digit))

    def nap_cmd_LOGIN_ATTEMPT(self, _):
        #self.irc_reply(002, ":Login successful %s" % m)
        self.irc_notice("Someone is logging as you. Disconecting...")
        self.exit_immediately = 1

    def nap_cmd_DATA_PORT_ERROR(self, m):
        #self.irc_reply(002, ":Login successful %s" % m)
        self.irc_notice("Oh dear... we confused %s, he cannot download..." % m)

    def donap(self, cmd):
        if not cmd:
            self.irc_notice("Napster server kicked you out")
            raise "session_exit"
            return
        t, m = cmd
        if self.nap_cmddict.has_key(t):
            self.nap_cmddict[t](m)
        else:
            self.irc_notice("Unhandled napster response: %i %s" % (t, m))

    # parses the irc command and eventually calls the appropriate routine
    def docmd(self, cmd):
        debug("C:"+repr(cmd))
        # if the connection has broken... we have to shut down:
        if cmd == "":
            raise "session_exit"
        # filter suspicious chars first
        cmd2 = filter(lambda x: ord(x) >= 32, cmd)
        if not cmd2:
            return
        # filter prefix second
        if cmd2[0] == ':':
            cmd2 = string.split(cmd2, ' ', 1)[1]
            cmd2 = string.lstrip(cmd2) # not quite correct
        # filter trailing arg third
        cmd2 = string.split(cmd2, ':', 1)
        args = []
        lcmd2 = string.split(cmd2[0]) # again, not quite correct (should use space, not whitespace)
        if len(cmd2) == 2 and cmd2[1]: # only if trailing arg is not empty
            args = [cmd2[1]]
        else:
            args = []
        cmd2 = lcmd2[0]
        args = lcmd2[1:]+args
        if not cmd2:
            return
        command = string.upper(cmd2)

        u = self.nick or "-"
        ip = self.ip or "-"
        if command == "pass":
            c = "PASS ****"
        else:
            c = cmd2
        log.log("%s: %s@%s : %s" % (time.ctime(time.time()), u, ip, c))
        if self.irc_cmddict.has_key(command):
            apply(self.irc_cmddict[command], args)
            return
        else:
            self.irc_reply(421, command+" :I am gonna ignore this command... maybe later...")
            return

    def loop(self):
        try:
            while not self.exit_immediately:
                self.last_cmd_time = time.time()
                list = [self.irc_rfile, self.nap_sock.sock]
                lirc = ""
                lnap = ""
                r,w,e = select.select(list, [], [])
                if self.irc_rfile in r:
                    lirc = r[0].readline()
                    self.docmd(lirc)
                if self.nap_sock.sock in r:
                    lnap = self.nap_sock.receive()
                    self.donap(lnap)
        except ("session_exit", socket.error):
            pass
        self.nap_sock.close()
        debug("Connection closed.")

    

class NapSock:

    def __init__(self, sock):
        self.sock = sock
        self.lock = thread.allocate_lock()

    def connect(self, adr):
        self.sock.connect(adr)

    def send(self, t, data=""):
        self.lock.acquire()
        l = len(data)
        r = chr(l%256)+chr(l/256)+chr(t%256)+chr(t/256)+data
        self.sock.send(r)
        self.lock.release()

    def readlen(self, l):
        if not l:
            return ""
        toread = l
        done = 0
        s = ""
        while len(s)<l:
            r = self.sock.recv(l-len(s))
            if not r:
                debug("Connection broken by napster server")
                return ""
            s = s+r
        return s

    def readtwo(self):
        s = self.readlen(2)
        if not s:
            return ""
        return ord(s[0])+256*ord(s[1])

    def receive(self):
        self.lock.acquire()
        l = self.readtwo()
        t = self.readtwo()
        s = self.readlen(l)
        if len(s)<>l:
            r = None
        else:
            r = t, s
        self.lock.release()
        return r

    def close(self):
        self.sock.close()



# the main routine
# ----------------


try:
    import thread
    threading = 1
except:
    threading = 0



class MyStreamRequestHandler(SocketServer.StreamRequestHandler):
    def finish(self):
        self.wfile.flush()
        self.wfile.close()
        self.rfile.close()
        self.request.close()


class TCPServer(SocketServer.TCPServer):
    def server_bind(self):
        """Called by constructor to bind the socket.
        """
        self.socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        self.socket.bind(self.server_address)

    def get_request(self):
        """Get the request and client address from the socket.
        """
        conn, adr = self.socket.accept()
        #conn = my_socket(sock=conn, timeout=timeout_session)
        return conn, adr

class ThreadingTCPServer(SocketServer.ThreadingMixIn, TCPServer):
    pass


class NapyrcServer(MyStreamRequestHandler):
    def handle(self):
        global session
        session = Session(self.rfile, self.wfile, self.client_address)
        session.loop()
        del session

pid = 0

class UploadingServer(MyStreamRequestHandler):
    def handle(self):
        global pid
        upsession = UploadingSession(self.connection, self.client_address)
        thispid = pid = pid + 1
        uploads[thispid] = upsession
        upsession.go()
        del uploads[thispid]
        del upsession


log = Log(logfile)

address = ('', ircport)
server = TCPServer(address, NapyrcServer)

upaddress = ('', client_port)
upserver = ThreadingTCPServer(upaddress, UploadingServer)

thread.start_new_thread(upserver.serve_forever, ())

server.serve_forever()
#server.handle_request()

