#!/usr/bin/python
# maybe you need to change the above line

import sys, socket, string, os, fnmatch
from stat import *
import mp3infor

from logging import *
from config import *

def mp3info(file):
     try:
         mp3 = mp3infor.open_mp3(file)
     except IOError:
             return None
     try:
         size = os.stat(file)[ST_SIZE]
         mp3.sync_read_header(0, 500)
         version = mp3.get_mpeg_version()
         layer = mp3.get_layer()
         protection_bit = mp3.get_protection()
         bitrate = mp3.get_bitrate()
         frequency = mp3.get_frequency()
         ch_mode = mp3.get_channel_mode()
         copyright  = mp3.get_copyright()
         original_bit = mp3.get_original()
         seconds, minutes, seconds_remain = mp3.get_length()
         frame = mp3.get_framelength()
     except mp3infor.NoHeaderError:
         bitrate = 32
         frequency = 32000
         seconds = 32
     return '00000000000000000000000000000000-%i' % size, size, bitrate, frequency, seconds
         # file, md5hash, size, bitrate, frequency, length

def walk(top, func, arg):
    """walk(top,func,args) calls func(arg, d, files) for each directory "d" 
in the tree  rooted at "top" (including "top" itself).  "files" is a list
of all the files and subdirs in directory "d".
"""
    try:
        names = os.listdir(top)
    except os.error:
        return
    func(arg, top, names)
    exceptions = (os.curdir, os.pardir)
    for name in names:
        if name not in exceptions:
            name = os.path.join(top, name)
            if os.path.isdir(name):
                walk(name, func, arg)


def nsplit(s, maxfields=0):
    r =  string.split(s, '"')
    v = []
    for i in range(len(r)):
        if not (i%2): #even 
            v.extend(string.split(r[i]))
        else:
            v.append(r[i])
    if maxfields>0 and len(v) > maxfields+1:
        v = v[:maxfields]+[string.join(v[maxfields:])]
    return v

def v2fs(file):
    if file[-19:] == '|not really an|.MP3':
        file = file[:-19]
    return string.replace(file, "\\", os.sep)    

def fs2v(file):
    if not os.path.splitext(file)[1] in ('.mp3', '.MP3'):
        file = file+'|not really an|.MP3'
    return string.replace(file, os.sep, "\\")
    
def format_size(s):
    power = 1024
    if s == 0:
        return "0"
    units = ["kB", "MB", "GB", "TB"]
    r = `s` + "B"
    for i in range(len(units)):
        if s/power > 9:
            s = s/power
            r = `s` + units[i]
    return r
    
def format_length(s):
    if s/60 == 0:
        return `s`+'s'
    else:
        return `s/60`+'m'+`s%60`+'s'
    
def makeip(ip):
    ip = long(ip)
    r = ''
    for i in range(4):
        r = r+`int(ip%256)`+'.'
        ip = ip/256
    return r[:-1]

